#include "gtest/gtest.h"
#include "Spiral.h"
#include <iostream>
#include <string>
#include <vector>
using namespace std;

class Testing : public ::testing::Test {

protected:
    Testing() {}
    virtual ~Testing() {
    }

    virtual void SetUp() {}
    
    virtual void TearDown() {
	cout << endl << ":::END" << endl;
    }
};
    

TEST_F(Testing, constructor) {
    cout << ":::NAME test constructor and getters" << endl;
    cout << ":::MAX_SCORE 5" << endl;
    cout << ":::SCORE 5" << endl;
    cout << ":::VISIBILITY visible" << endl;
    cout << "\nTesting with \n\nSpiral testSpiral(0,0, 90.0, 100.0);\n" << endl;
    cout << "to make a spiral centered on (0,0) with a start radius of 100\n and 90 degrees clockwise from 12 o'clock." << endl;
    cout << "Based on this, the initial spiral point should be \nat (100,0) with a text angle of 90." << endl;
    Spiral testSpiral(0,0, 90.0, 100.0);
    cout << "Calling the getters for Spiral returns:" << endl;
    cout << "testSpiral.getTextX() -> " << testSpiral.getTextX() << endl;
    cout << "testSpiral.getTextY() -> " << testSpiral.getTextY() << endl;
    cout << "testSpiral.getLetterAngle() -> " << testSpiral.getLetterAngle() << endl;
    
    EXPECT_NEAR(100.0, testSpiral.getTextX(), 1e-13) << ":::SCORE 0";
    EXPECT_NEAR(0.0, testSpiral.getTextY(), 1e-13) << ":::SCORE 0";
    EXPECT_NEAR(90.0, testSpiral.getLetterAngle(), 1e-13) << ":::SCORE 0";
}

TEST_F(Testing, preincrement) {
    cout << ":::NAME test ++Spiral" << endl;
    cout << ":::MAX_SCORE 2" << endl;
    cout << ":::SCORE 2" << endl;
    cout << ":::VISIBILITY visible" << endl;
    Spiral testSpiral(0,0, 0.0, 100.0);
    Spiral newSpiral = ++testSpiral;
    EXPECT_NE(0.0, testSpiral.getLetterAngle()) << ":::SCORE 0";
}

TEST_F(Testing, postincrement) {
    cout << ":::NAME test Spiral++" << endl;
    cout << ":::MAX_SCORE 3" << endl;
    cout << ":::SCORE 3" << endl;
    cout << ":::VISIBILITY visible" << endl;
    Spiral testSpiral(0,0, 0.0, 100.0);
    Spiral oldSpiral = testSpiral++;
    EXPECT_NE(0.0, testSpiral.getLetterAngle()) << ":::SCORE 0";
    EXPECT_NEAR(0.0, oldSpiral.getLetterAngle(), 1e-13) << ":::SCORE 0";
}
